#include "mipc3.h"
pthread_t       threadread, threadwrite;
sigset_t allsig,oldmask;
/* read from shared memory from client and write to stdout*/
void shm_read(memory *mem)
{ int n,signr;
  while (1) {
        signr=SIGUSR1;
        sigwait(&allsig,&signr);
        pthread_mutex_lock(&mem->rdmut);
        write(1,"\n",1);
        write(1,mem->txt1,mem->lgt1);
        write(1,"s> ",3);
        pthread_mutex_unlock(&mem->rdmut);
  }
  pthread_cancel(threadwrite);
  n=0; pthread_exit(&n);
}
/* read from stdin and write in shared memory to client*/
void shm_write( memory *mem)
{ int n,lgt;
  char buf[80];
  while (1) {
        write(1,"S> ",3);
        if ((lgt = read(0,buf,80)) <= 0) break ;
        pthread_mutex_lock(&mem->wrmut);
        strncpy(mem->txt2,buf,lgt);
        mem->lgt2=lgt;
        pthread_mutex_unlock(&mem->wrmut);
        kill(mem->cpid,SIGUSR1); 
  }
  pthread_cancel(threadread);
  n=0; pthread_exit(&n);
}
int main()
{  int shmid;
   memory *mem;
   if ((shmid=shmget(KEY_SHM,sizeof(memory),0777|IPC_CREAT)) < 0) {
        fprintf(stderr,"error shmget: %ld\n",KEY_SHM); exit(-2);
   }
   if ((mem = shmat(shmid,(char *) 0,0)) == NULL) {
	fprintf(stderr,"error shmat\n"); exit(-3);
   }
   sigfillset(&allsig);
   sigprocmask(SIG_BLOCK,&allsig,&oldmask);
   mem->spid=getpid();
   pthread_mutex_init(&mem->wrmut,NULL);
   pthread_mutex_init(&mem->rdmut,NULL);
   pthread_create(&threadread,NULL, (void *) shm_read, (void *) mem );
   pthread_create(&threadwrite,NULL, (void *) shm_write, (void *) mem );
   pthread_join(threadread, NULL);
   pthread_join(threadwrite, NULL);
   kill(mem->cpid,15);
   shmdt((void *)mem);
   shmctl(shmid,IPC_RMID,(struct shmid_ds *) 0);
   exit(0);
}
